#include "header.h"
#include "blackScholes.h"
#include "util.h"
#include <math.h>
#include <stdio.h>
/*
double mask[POINTS_SIZE],S8U[UNDERLIERS_SIZE],S7U[UNDERLIERS_SIZE],g[POINTS_SIZE];
*/

/* Calculates the mesh estimae of [t][p] using inner control 3.
 * Updates Prob[t][p][u].  Prob[t][p][u] should be initialized before
 * the first call.  */


/* the entire routine takes 7.41E-05 */

double mesh_estimate_3(int t, int p){
  int points, u;
  double S1,S2,S7,S8,S9,S10,S12,S13,G,beta;
  int p2;
  int i;


  double mask[POINTS_SIZE],S8U[UNDERLIERS_SIZE],S7U[UNDERLIERS_SIZE],g[POINTS_SIZE ];    



  int count_g;
  int tp1 = t+1;
  int zero = 0;

  weights1(t,p,tp1);
  

  points = points_on_timeslice(tp1);
  G = exp(-INTEREST*t)*maxOf2Risk(Price[t][ Max1[t][p] ][p], Price[t][ Max2[t][p] ][p], STRIKE, 1.0, sqrt(VARIANCE),
				  sqrt(VARIANCE), INTEREST, DIVIDEND, DIVIDEND, 0.0);
  
  

  for(p2=0;p2<points;++p2){
    g[p2] = dMax(Price[tp1][ Max1[t][p] ][p2], Price[tp1][ Max2[t][p] ][p2]);
    g[p2]  = dMax(0, exp(-INTEREST*(tp1))*(g[p2] - STRIKE));
  }
  

  S1 = 0;
  S2 = 0;
  S7 = 0;
  S8 = 0;
  S9 = 0;
  S10 = 0;
  S12 = 0;
  S13 = 0;

  count_g = 0;
  for(u=0;u<UNDERLIERS;++u){
    S7U[u] = 0.0;
    S8U[u] = 0.0;
    if (Underlier_mask[u]) ++count_g;
  }
  

/* this part takes 2.47E-05 */

  for(p2=0;p2<points;++p2){
    fflush(stdout);
    mask[p2] = Underlier_mask[Max1[tp1][p2]]*Underlier_mask[ Max2[tp1][p2] ];
  }
  

  p2 = 0;
  for(u=0;u<UNDERLIERS;++u){
    printf("Number_with_max=%d\n",Number_with_max[tp1][u]);
    for(i=0;i<Number_with_max[tp1][u];i++){
      printf("u = %d p2=%d i=%d\n",u,p2,i); 
      S7U[u] += mask[p2]*Weight[p2]*Value[tp1][p2];
      S8U[u] += mask[p2]*Weight[p2] * (g[p2] - G);      
      ++p2;
    }
  }

  
/*   for(p2=0;p2<points;++p2){ */
/*     S7U[ Max1[tp1][p2] ] += mask[p2]*Weight[p2] * Value[tp1][p2]; */
/*     S8U[ Max1[tp1][p2] ] += mask[p2]*Weight[p2] * (g[p2] - G); */
/*   } */
 
  

  for(p2=0;p2<points;++p2){
    S1  += mask[p2]*Weight[p2];
    S2  += mask[p2]*Weight[p2] * Weight[p2];
    S7  += mask[p2]*Weight[p2] * Value[tp1][p2];
    S8  += mask[p2]*Weight[p2] * (g[p2] - G);
    S9  += mask[p2]*Weight[p2] * Weight[p2] * Value[tp1][p2];
    S10 += mask[p2]*Weight[p2] * Weight[p2] * (g[p2] - G);
    S12 += mask[p2]*Weight[p2] * Weight[p2] * Value[tp1][p2] * (g[p2] - G);
    S13 += mask[p2]*Weight[p2] * Weight[p2] * (g[p2] - G) * (g[p2] - G);    
/*     } */
  }
  

  if (S1 ==0) printf("BUG3-->,%d\n",count_g);
  if((S13/S1 - 2*S8*S10/(S1*S1) + S2*S8*S8/(S1*S1*S1)) == 0){
    for(u=0;u<UNDERLIERS;++u){
      Prob[t][u][p] = S7U[u]/S1;
    }
    return(S7/S1);
  }
  
  beta = (S12/S1 - (S8*S9 + S7*S10)/(S1*S1) + S2*S7*S8/(S1*S1*S1))/
    (S13/S1 - 2*S8*S10/(S1*S1) + S2*S8*S8/(S1*S1*S1));

  if(fabs(beta) > 2.0){
    for(u=0;u<UNDERLIERS;++u){
      Prob[t][u][p] = S7U[u]/S1;
    }
     return(S7/S1);
  }

  for(u=0;u<UNDERLIERS;++u){
    Prob[t][u][p] = (S7U[u] - beta*S8U[u])/S1;
  }

  return((S7-beta*S8)/S1);
}


double mesh_estimate_0(int t, int p){
  int p2, points;
  double vih=0;

  weights1(t,p,t+1);

  points = points_on_timeslice(t+1);

  /* DEBUG */
#if DEBUG
  for(p2=0;p2<points;++p2){
    printf("[%i][%i] -> [%i][:] Weight[%i] = %16g\t Value[%i][%i] = %f\n",t,p,t+1,p2,Weight[p2],t+1,p2,Value[t+1][p2]);
  }
  printf("Sum_weights = %g\n",Sum_weights);
#endif


  for(p2=0;p2<points;++p2){
    vih += Weight[p2]*Value[t+1][p2];
  }
  return(vih/Sum_weights);
}
#include <math.h>
#include <stdio.h>
#include "header.h"

int generate_mask(int t1, int p1){
  int points, u, ig,swapped,tmp2, index[UNDERLIERS_SIZE];
  double p[UNDERLIERS_SIZE],tmp;
  static int calls=0;

  /*   calls++; */
  /* printf("%i\n",calls);*/
  ig = 0;

  for(u=0;u<UNDERLIERS;++u){ 
    Underlier_mask[u] = 1;
    p[u] = Prob[t1][u][p1];
    index[u] = u;
  }

  do{
    swapped = 0;
    for(u=1;u<UNDERLIERS;++u){
      if(p[u] < p[u-1]){
	swapped = 1;
	tmp = p[u];
	p[u] = p[u-1];
	p[u-1] = tmp;
	tmp2 = index[u];
	index[u] = index[u-1];
	index[u-1] = tmp2;
      }
    }
  }while(swapped);

  for(u=0;u<UNDERLIERS;++u){
    if(p[u] < Prob[t1][u][p1]){
      ++ig;
    }
  }

  if(ig > MAXIGNORE) ig = MAXIGNORE;

  for(u=0; u<ig;++u){
    Underlier_mask[ index[u] ] = 0;
  }


  /*  if(PROBCUTOFF){ */
  /*     for(u=0; u<UNDERLIERS; ++u){ */
  /*       if(Prob[t1][u][p1] < PROBCUTOFF){ */
  /* 	Underlier_mask[u] = 0; */
  /* 	++ig; */
  /*       } */
  /*     } */
  /*   } */
  
  Ignore[t1] += (double)ig;
  ++Ignore_den[t1];
  return(ig);
}


/* Fill Weight[p2] with weights from (t1,p1) -> (t2,*) 
 * This is stretched out to be readable.  Variables can be 
 * eliminated and loops combined.  Includes the subterfuge.
 */
void weights1(int t1, int p1, int t2){
  int u, p2, points, eu, ig, min,found;
  double f[POINTS_SIZE], arg[POINTS_SIZE], growth[UNDERLIERS_SIZE][POINTS_SIZE],num_det,den_det;
  double g[POINTS_SIZE];
  static int last_t2 = -1;

  /*   printf("weights1(%i,%i,%i)\n",t1,p1,t2); */

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  ig = generate_mask(t1,p1);

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS-ig);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }

  den_det = pow( sqrt(VARIANCE), UNDERLIERS-ig);
    
  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
  }
  if (Sum_weights ==0) printf("BUG\n");
}

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) This is
 * stretched out to be readable.  Variables can be eliminated and
 * loops combined.  Does not include the subterfuge, so it can be used
 * to calculate the probabilities needed to implement the subterfuge.
 * */

void weights2(int t1, int p1, int t2){
  int u, p2, points;
  double f[POINTS_SIZE], arg[POINTS_SIZE], growth[UNDERLIERS_SIZE][POINTS_SIZE],num_det,den_det;
  static double g[POINTS_SIZE];
  static int last_t2 = -1;

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += (growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	arg[p2] += (growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }
    
  den_det = pow( sqrt(VARIANCE), UNDERLIERS);

  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2]/(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += f[p2]/g[p2];
  }
  if (Sum_weights ==0) printf("BUG\n");
}
